diff --git a/src/backend/storage/smgr/md.c b/src/backend/storage/smgr/md.c
index 3998296a62..bfb933e617 100644
--- a/src/backend/storage/smgr/md.c
+++ b/src/backend/storage/smgr/md.c
@@ -1419,3 +2067,736 @@ mdfiletagmatches(const FileTag *ftag, const FileTag *candidate)
 	 */
 	return ftag->rlocator.dbOid == candidate->rlocator.dbOid;
 }
+
+static int
+sync_pcmap(PageCompressHeader *pcmap, uint32 wait_event_info)
+{
+	int			returnCode;
+	uint32		nblocks,
+				allocated_chunks,
+				last_synced_nblocks,
+				last_synced_allocated_chunks;
+
+	nblocks = pg_atomic_read_u32(&pcmap->nblocks);
+	allocated_chunks = pg_atomic_read_u32(&pcmap->allocated_chunks);
+	last_synced_nblocks = pg_atomic_read_u32(&pcmap->last_synced_nblocks);
+	last_synced_allocated_chunks = pg_atomic_read_u32(&pcmap->last_synced_allocated_chunks);
+
+	pgstat_report_wait_start(wait_event_info);
+	returnCode = pc_msync(pcmap);
+	pgstat_report_wait_end();
+
+	if (returnCode == 0)
+	{
+		if (last_synced_nblocks != nblocks)
+			pg_atomic_write_u32(&pcmap->last_synced_nblocks, nblocks);
+
+		if (last_synced_allocated_chunks != allocated_chunks)
+			pg_atomic_write_u32(&pcmap->last_synced_allocated_chunks, allocated_chunks);
+	}
+
+	return returnCode;
+}
+
+static void
+build_compression_chunks(char *data, int size, char *chunk_buf, int total_chunks,
+						 PageCompressAddr *pcaddr, int chunk_size, BlockNumber blocknum)
+{
+	int			data_chunks = NeedPageCompressChunksToStoreData(chunk_size, size);
+	int			i;
+
+	/* build chunks of compressed page */
+	for (i = 0; i < total_chunks; i++)
+	{
+		char	   *pos;
+		PageCompressChunk *pcchunk = (PageCompressChunk *) (chunk_buf + chunk_size * i);
+
+		if (i < data_chunks - 1)
+		{
+			pos = data + StoreCapacityPerPageCompressChunk(chunk_size) * i;
+			memcpy(pcchunk->data, pos, StoreCapacityPerPageCompressChunk(chunk_size));
+			pcchunk->withdata = 1;
+		}
+		else if (i == data_chunks - 1)
+		{
+			int			datasize = size - StoreCapacityPerPageCompressChunk(chunk_size) * i;
+
+			pos = data + StoreCapacityPerPageCompressChunk(chunk_size) * i;
+			memcpy(pcchunk->data, pos, datasize);
+
+			/* fill zero in the rest space */
+			if (StoreCapacityPerPageCompressChunk(chunk_size) > datasize)
+				memset(pcchunk->data + datasize, 0x00, StoreCapacityPerPageCompressChunk(chunk_size) - datasize);
+
+			pcchunk->withdata = 1;
+		}
+		else
+		{
+			/* fill zero in the prealloced chunk */
+			memset(pcchunk->data, 0x00, StoreCapacityPerPageCompressChunk(chunk_size));
+			pcchunk->withdata = 0;
+		}
+
+		pcchunk->blockno = blocknum;
+		pcchunk->chunkseq = i + 1;
+		if (DataChecksumsEnabled())
+			pcchunk->checksum = pg_checksum_compress_chunk((char *) pcchunk, chunk_size, pcaddr->chunknos[i]);
+		else
+			pcchunk->checksum = 0;
+	}
+}
+
+/*
+ * mdextend_pc() -- Add a block to the specified compressed relation.
+ *
+ */
+static void
+mdextend_pc(SMgrRelation reln, ForkNumber forknum, BlockNumber blocknum,
+			char *buffer, bool skipFsync)
+{
+	MdfdVec    *v;
+	char	   *work_buffer,
+			   *chunk_buffer;
+	int			i,
+				work_buffer_size,
+				compressed_page_size;
+	int			prealloc_chunks,
+				need_chunks,
+				write_chunks,
+				chunk_size,
+				nchunks;
+	pc_chunk_number_t chunkno;
+	PageCompressHeader *pcmap;
+	PageCompressAddr *pcaddr;
+	uint8		algorithm;
+	int8		level;
+
+	/* This assert is too expensive to have on normally ... */
+#ifdef CHECK_WRITE_VS_EXTEND
+	Assert(blocknum >= mdnblocks(reln, forknum));
+#endif
+
+	Assert(IS_COMPRESSED_MAINFORK(reln, forknum));
+
+	/*
+	 * If a relation manages to grow to 2^32-1 blocks, refuse to extend it any
+	 * more --- we mustn't create a block whose number actually is
+	 * InvalidBlockNumber.
+	 */
+	if (blocknum == InvalidBlockNumber)
+		ereport(ERROR,
+				(errcode(ERRCODE_PROGRAM_LIMIT_EXCEEDED),
+				 errmsg("cannot extend file \"%s\" beyond %u blocks",
+						relpath(reln->smgr_rlocator, forknum),
+						InvalidBlockNumber)));
+
+	v = _mdfd_getseg(reln, MAIN_FORKNUM, blocknum, skipFsync, EXTENSION_CREATE);
+
+	chunk_size = PAGE_COMPRESS_CHUNK_SIZE(reln);
+	algorithm = PAGE_COMPRESS_ALGORITHM(reln);
+	level = PAGE_COMPRESS_LEVEL(reln);
+	prealloc_chunks = PAGE_COMPRESS_PREALLOC_CHUNKS(reln);
+	if (prealloc_chunks > BLCKSZ / chunk_size - 1)
+		prealloc_chunks = BLCKSZ / chunk_size - 1;
+
+	pcmap = (PageCompressHeader *) GetPageCompressMemoryMap(v->mdfd_vfd_pca, chunk_size);
+	pcaddr = GetPageCompressAddr(pcmap, chunk_size, blocknum);
+
+	Assert(blocknum % RELSEG_SIZE >= pg_atomic_read_u32(&pcmap->nblocks));
+
+	/*
+	 * If the initial allocated space is not enough, it may cause the storage
+	 * space to be discontinuous. Therefore, postpone space allocation of the
+	 * new page until the page is flushed later.
+	 */
+	if (PageIsNew(buffer))
+	{
+		if (pg_atomic_read_u32(&pcmap->nblocks) < blocknum % RELSEG_SIZE + 1)
+			pg_atomic_write_u32(&pcmap->nblocks, blocknum % RELSEG_SIZE + 1);
+
+		if (!skipFsync && !SmgrIsTemp(reln))
+			register_dirty_segment(reln, forknum, v);
+
+		Assert(_mdnblocks(reln, forknum, v) <= ((BlockNumber) RELSEG_SIZE));
+
+		return;
+	}
+
+	/* check allocated chunk number */
+	if (pcaddr->allocated_chunks > MaxChunksPreCompressedPage(chunk_size))
+		ereport(ERROR,
+				(errcode(ERRCODE_DATA_CORRUPTED),
+				 errmsg("invalid allocated chunks %u of block %u in file \"%s\"",
+						pcaddr->allocated_chunks, blocknum, FilePathName(v->mdfd_vfd_pca))));
+
+	for (i = 0; i < pcaddr->allocated_chunks; i++)
+	{
+		if (pcaddr->chunknos[i] <= 0 || pcaddr->chunknos[i] > MAX_PAGE_COMPRESS_CHUNK_NUMBER(chunk_size))
+			ereport(ERROR,
+					(errcode(ERRCODE_DATA_CORRUPTED),
+					 errmsg("invalid chunk number %u of block %u in file \"%s\"",
+							pcaddr->chunknos[i], blocknum, FilePathName(v->mdfd_vfd_pca))));
+	}
+
+	/* compress page */
+	work_buffer_size = compress_page_buffer_bound(algorithm);
+	if (work_buffer_size < 0)
+		ereport(ERROR,
+				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+				 errmsg("unrecognized compression algorithm %d",
+						algorithm)));
+	work_buffer = palloc(work_buffer_size);
+
+	compressed_page_size = compress_page(buffer, work_buffer, work_buffer_size, algorithm, level);
+
+	if (compressed_page_size < 0)
+		elog(ERROR, "compression failed with algorithm %d", algorithm);
+
+	nchunks = NeedPageCompressChunksToStoreData(chunk_size, compressed_page_size);
+	if (nchunks > MaxChunksPreCompressedPage(chunk_size))
+		elog(ERROR, "size of compressed page %d exceeds the limit when write block %u of file \"%s\"",
+			 compressed_page_size, blocknum, FilePathName(v->mdfd_vfd));
+
+	/* allocate chunks needed */
+	need_chunks = prealloc_chunks > nchunks ? prealloc_chunks : nchunks;
+	if (pcaddr->allocated_chunks < need_chunks)
+	{
+		int			max_chunkno = pg_atomic_read_u32(&pcmap->allocated_chunks) + need_chunks - pcaddr->allocated_chunks + 1;
+
+		if (max_chunkno > MAX_PAGE_COMPRESS_CHUNK_NUMBER(chunk_size))
+			ereport(ERROR,
+					(errcode(ERRCODE_DATA_CORRUPTED),
+					 errmsg("try to allocate too many chunks %d in file \"%s\"",
+							max_chunkno, FilePathName(v->mdfd_vfd_pca))));
+
+		/*
+		 * First atomically increase the global number of chunks, which allows
+		 * multiple backends to allocate chunks concurrently.
+		 */
+		chunkno = (pc_chunk_number_t) pg_atomic_fetch_add_u32(&pcmap->allocated_chunks,
+															  need_chunks - pcaddr->allocated_chunks) + 1;
+		for (i = pcaddr->allocated_chunks; i < need_chunks; i++, chunkno++)
+		{
+			pcaddr->chunknos[i] = chunkno;
+		}
+		pcaddr->allocated_chunks = need_chunks;
+
+		/*
+		 * Every time COMPRESS_ADDRESS_SYNC_THRESHOLD chunks are allocated,
+		 * the address fileis flashed once to avoid too many addresses that
+		 * need to be repaired after crash.
+		 */
+		if (pg_atomic_read_u32(&pcmap->allocated_chunks) - pg_atomic_read_u32(&pcmap->last_synced_allocated_chunks) >
+			COMPRESS_ADDRESS_SYNC_THRESHOLD(chunk_size))
+		{
+			if (sync_pcmap(pcmap, WAIT_EVENT_COMPRESS_ADDRESS_FILE_FLUSH) != 0)
+				ereport(data_sync_elevel(ERROR),
+						(errcode_for_dynamic_shared_memory(),
+						 errmsg("could not msync file \"%s\": %m",
+								FilePathName(v->mdfd_vfd_pca))));
+		}
+
+		write_chunks = need_chunks;
+	}
+	else
+	{
+		write_chunks = nchunks >= pcaddr->nchunks ? nchunks : pcaddr->nchunks;
+		if (write_chunks > pcaddr->allocated_chunks)
+			write_chunks = pcaddr->allocated_chunks;
+	}
+
+	/* build chunks of compressed page */
+	chunk_buffer = palloc(chunk_size * write_chunks);
+	build_compression_chunks(work_buffer, compressed_page_size, chunk_buffer, write_chunks, pcaddr, chunk_size, blocknum);
+
+	/* write chunks of compressed page */
+	for (i = 0; i < need_chunks; i++)
+	{
+		char	   *pos = chunk_buffer + chunk_size * i;
+		off_t		seekpos = (off_t) OffsetOfPageCompressChunk(chunk_size, pcaddr->chunknos[i]);
+		int			range = 1;
+		int			write_amount,
+					nbytes;
+
+		/* write multiple consecutive chunks at once */
+		while (i < need_chunks - 1 && pcaddr->chunknos[i + 1] == pcaddr->chunknos[i] + 1)
+		{
+			range++;
+			i++;
+		}
+		write_amount = chunk_size * range;
+
+		TRACE_POSTGRESQL_SMGR_MD_WRITE_START(forknum, blocknum,
+											 reln->smgr_rlocator.locator.spcNode,
+											 reln->smgr_rlocator.locator.dbNode,
+											 reln->smgr_rlocator.locator.relNode,
+											 reln->smgr_rlocator.backend);
+
+		nbytes = FileWrite(v->mdfd_vfd_pcd, pos, write_amount, seekpos, WAIT_EVENT_DATA_FILE_EXTEND);
+
+		TRACE_POSTGRESQL_SMGR_MD_WRITE_DONE(forknum, blocknum,
+											reln->smgr_rlocator.locator.spcNode,
+											reln->smgr_rlocator.locator.dbNode,
+											reln->smgr_rlocator.locator.relNode,
+											reln->smgr_rlocator.backend,
+											nbytes,
+											write_amount);
+
+		if (nbytes != write_amount)
+		{
+			if (nbytes < 0)
+				ereport(ERROR,
+						(errcode_for_file_access(),
+						 errmsg("could not extend file \"%s\": %m",
+								FilePathName(v->mdfd_vfd_pcd)),
+						 errhint("Check free disk space.")));
+
+			/* short write: complain appropriately */
+			ereport(ERROR,
+					(errcode(ERRCODE_DISK_FULL),
+					 errmsg("could not extend file \"%s\": wrote only %d of %d bytes at block %u",
+							FilePathName(v->mdfd_vfd_pcd),
+							nbytes, write_amount, blocknum),
+					 errhint("Check free disk space.")));
+		}
+	}
+
+	/* finally update size of this page and global nblocks */
+	if (pcaddr->nchunks != nchunks)
+		pcaddr->nchunks = nchunks;
+
+	if (pg_atomic_read_u32(&pcmap->nblocks) < blocknum % RELSEG_SIZE + 1)
+		pg_atomic_write_u32(&pcmap->nblocks, blocknum % RELSEG_SIZE + 1);
+
+	if (work_buffer != buffer)
+		pfree(work_buffer);
+
+	if (!skipFsync && !SmgrIsTemp(reln))
+		register_dirty_segment(reln, forknum, v);
+
+	Assert(_mdnblocks(reln, forknum, v) <= ((BlockNumber) RELSEG_SIZE));
+}
+
+/*
+ *	mdwrite_pc() -- Write the supplied block to a compressed relation.
+ *
+ *		This is to be used only for updating already-existing blocks of a
+ *		relation (ie, those before the current EOF).  To extend a relation,
+ *		use mdextend().
+ */
+static void
+mdwrite_pc(SMgrRelation reln, ForkNumber forknum, BlockNumber blocknum,
+		   char *buffer, bool skipFsync)
+{
+	MdfdVec    *v;
+	char	   *work_buffer,
+			   *chunk_buffer;
+	int			i,
+				work_buffer_size,
+				compressed_page_size;
+	int			prealloc_chunks,
+				need_chunks,
+				write_chunks,
+				chunk_size,
+				nchunks;
+	pc_chunk_number_t chunkno;
+	PageCompressHeader *pcmap;
+	PageCompressAddr *pcaddr;
+	uint8		algorithm;
+	int8		level;
+
+	/* This assert is too expensive to have on normally ... */
+#ifdef CHECK_WRITE_VS_EXTEND
+	Assert(blocknum < mdnblocks(reln, forknum));
+#endif
+
+	Assert(IS_COMPRESSED_MAINFORK(reln, forknum));
+
+	v = _mdfd_getseg(reln, forknum, blocknum, skipFsync,
+					 EXTENSION_FAIL | EXTENSION_CREATE_RECOVERY);
+
+	chunk_size = PAGE_COMPRESS_CHUNK_SIZE(reln);
+	algorithm = PAGE_COMPRESS_ALGORITHM(reln);
+	level = PAGE_COMPRESS_LEVEL(reln);
+	prealloc_chunks = PAGE_COMPRESS_PREALLOC_CHUNKS(reln);
+	if (prealloc_chunks > BLCKSZ / chunk_size - 1)
+		prealloc_chunks = BLCKSZ / chunk_size - 1;
+
+	pcmap = (PageCompressHeader *) GetPageCompressMemoryMap(v->mdfd_vfd_pca, chunk_size);
+	pcaddr = GetPageCompressAddr(pcmap, chunk_size, blocknum);
+
+	Assert(blocknum % RELSEG_SIZE < pg_atomic_read_u32(&pcmap->nblocks));
+
+	/* check allocated chunk number */
+	if (pcaddr->allocated_chunks > MaxChunksPreCompressedPage(chunk_size))
+		ereport(ERROR,
+				(errcode(ERRCODE_DATA_CORRUPTED),
+				 errmsg("invalid allocated chunks %u of block %u in file \"%s\"",
+						pcaddr->allocated_chunks, blocknum, FilePathName(v->mdfd_vfd_pca))));
+
+	for (i = 0; i < pcaddr->allocated_chunks; i++)
+	{
+		if (pcaddr->chunknos[i] <= 0 || pcaddr->chunknos[i] > MAX_PAGE_COMPRESS_CHUNK_NUMBER(chunk_size))
+			ereport(ERROR,
+					(errcode(ERRCODE_DATA_CORRUPTED),
+					 errmsg("invalid chunk number %u of block %u in file \"%s\"",
+							pcaddr->chunknos[i], blocknum, FilePathName(v->mdfd_vfd_pca))));
+	}
+
+	/* compress page */
+	work_buffer_size = compress_page_buffer_bound(algorithm);
+	if (work_buffer_size < 0)
+		ereport(ERROR,
+				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+				 errmsg("unrecognized compression algorithm %d",
+						algorithm)));
+	work_buffer = palloc(work_buffer_size);
+
+	compressed_page_size = compress_page(buffer, work_buffer, work_buffer_size, algorithm, level);
+
+	if (compressed_page_size < 0)
+		elog(ERROR, "compression failed with algorithm %d", algorithm);
+
+	nchunks = NeedPageCompressChunksToStoreData(chunk_size, compressed_page_size);
+	if (nchunks > MaxChunksPreCompressedPage(chunk_size))
+		elog(ERROR, "size of compressed page %d exceeds the limit when write block %u of file \"%s\"",
+			 compressed_page_size, blocknum, FilePathName(v->mdfd_vfd));
+
+	/* allocate chunks needed */
+	need_chunks = prealloc_chunks > nchunks ? prealloc_chunks : nchunks;
+	if (pcaddr->allocated_chunks < need_chunks)
+	{
+		int			max_chunkno = pg_atomic_read_u32(&pcmap->allocated_chunks) + need_chunks - pcaddr->allocated_chunks + 1;
+
+		if (max_chunkno > MAX_PAGE_COMPRESS_CHUNK_NUMBER(chunk_size))
+			ereport(ERROR,
+					(errcode(ERRCODE_DATA_CORRUPTED),
+					 errmsg("try to allocate too many chunks %d in file \"%s\"",
+							max_chunkno, FilePathName(v->mdfd_vfd_pca))));
+
+		/*
+		 * First atomically increase the global number of chunks, which allows
+		 * multiple backends to allocate chunks concurrently.
+		 */
+		chunkno = (pc_chunk_number_t) pg_atomic_fetch_add_u32(&pcmap->allocated_chunks,
+															  need_chunks - pcaddr->allocated_chunks) + 1;
+		for (i = pcaddr->allocated_chunks; i < need_chunks; i++, chunkno++)
+		{
+			pcaddr->chunknos[i] = chunkno;
+		}
+		pcaddr->allocated_chunks = need_chunks;
+
+		/*
+		 * Every time COMPRESS_ADDRESS_SYNC_THRESHOLD chunks are allocated,
+		 * the address fileis flashed once to avoid too many addresses that
+		 * need to be repaired after crash.
+		 */
+		if (pg_atomic_read_u32(&pcmap->allocated_chunks) - pg_atomic_read_u32(&pcmap->last_synced_allocated_chunks) >
+			COMPRESS_ADDRESS_SYNC_THRESHOLD(chunk_size))
+		{
+			if (sync_pcmap(pcmap, WAIT_EVENT_COMPRESS_ADDRESS_FILE_FLUSH) != 0)
+				ereport(data_sync_elevel(ERROR),
+						(errcode_for_dynamic_shared_memory(),
+						 errmsg("could not msync file \"%s\": %m",
+								FilePathName(v->mdfd_vfd_pca))));
+		}
+
+		write_chunks = need_chunks;
+	}
+	else
+	{
+		write_chunks = nchunks >= pcaddr->nchunks ? nchunks : pcaddr->nchunks;
+		if (write_chunks > pcaddr->allocated_chunks)
+			write_chunks = pcaddr->allocated_chunks;
+	}
+
+	/* build chunks of compressed page */
+	chunk_buffer = palloc(chunk_size * write_chunks);
+	build_compression_chunks(work_buffer, compressed_page_size, chunk_buffer, write_chunks, pcaddr, chunk_size, blocknum);
+
+	/* write chunks of compressed page */
+	for (i = 0; i < need_chunks; i++)
+	{
+		char	   *pos = chunk_buffer + chunk_size * i;
+		off_t		seekpos = (off_t) OffsetOfPageCompressChunk(chunk_size, pcaddr->chunknos[i]);
+		int			range = 1;
+		int			write_amount,
+					nbytes;
+
+		/* write multiple consecutive chunks at once */
+		while (i < need_chunks - 1 && pcaddr->chunknos[i + 1] == pcaddr->chunknos[i] + 1)
+		{
+			range++;
+			i++;
+		}
+		write_amount = chunk_size * range;
+
+		TRACE_POSTGRESQL_SMGR_MD_WRITE_START(forknum, blocknum,
+											 reln->smgr_rlocator.locator.spcNode,
+											 reln->smgr_rlocator.locator.dbNode,
+											 reln->smgr_rlocator.locator.relNode,
+											 reln->smgr_rlocator.backend);
+
+		nbytes = FileWrite(v->mdfd_vfd_pcd, pos, write_amount, seekpos, WAIT_EVENT_DATA_FILE_WRITE);
+
+		TRACE_POSTGRESQL_SMGR_MD_WRITE_DONE(forknum, blocknum,
+											reln->smgr_rlocator.locator.spcNode,
+											reln->smgr_rlocator.locator.dbNode,
+											reln->smgr_rlocator.locator.relNode,
+											reln->smgr_rlocator.backend,
+											nbytes,
+											write_amount);
+
+		if (nbytes != write_amount)
+		{
+			if (nbytes < 0)
+				ereport(ERROR,
+						(errcode_for_file_access(),
+						 errmsg("could not write block %u in file \"%s\": %m",
+								blocknum, FilePathName(v->mdfd_vfd_pcd))));
+			/* short write: complain appropriately */
+			ereport(ERROR,
+					(errcode(ERRCODE_DISK_FULL),
+					 errmsg("could not write block %u in file \"%s\": wrote only %d of %d bytes",
+							blocknum,
+							FilePathName(v->mdfd_vfd_pcd),
+							nbytes, write_amount),
+					 errhint("Check free disk space.")));
+		}
+	}
+
+	/* finally update size of this page */
+	if (pcaddr->nchunks != nchunks)
+		pcaddr->nchunks = nchunks;
+
+	if (work_buffer != buffer)
+		pfree(work_buffer);
+
+	if (!skipFsync && !SmgrIsTemp(reln))
+		register_dirty_segment(reln, forknum, v);
+}
+
+/*
+ *	mdread_pc() -- Read the specified block from a compressed relation.
+ */
+static void
+mdread_pc(SMgrRelation reln, ForkNumber forknum, BlockNumber blocknum,
+		  char *buffer)
+{
+	off_t		seekpos;
+	int			nbytes,
+				chunk_size,
+				i,
+				read_amount,
+				range,
+				nchunks;
+	MdfdVec    *v;
+	PageCompressHeader *pcmap;
+	PageCompressAddr *pcaddr;
+	PageCompressChunk *pcchunk;
+	PageCompressData *pcdata;
+	char	   *compress_buffer,
+			   *buffer_pos;
+
+	Assert(IS_COMPRESSED_MAINFORK(reln, forkNum));
+
+	v = _mdfd_getseg(reln, forknum, blocknum, false,
+					 EXTENSION_FAIL | EXTENSION_CREATE_RECOVERY);
+
+	chunk_size = PAGE_COMPRESS_CHUNK_SIZE(reln);
+	pcmap = (PageCompressHeader *) GetPageCompressMemoryMap(v->mdfd_vfd_pca, chunk_size);
+	pcaddr = GetPageCompressAddr(pcmap, chunk_size, blocknum);
+
+	nchunks = pcaddr->nchunks;
+	if (nchunks == 0)
+	{
+		MemSet(buffer, 0, BLCKSZ);
+		return;
+	}
+
+	/* check chunk number */
+	if (nchunks > pcaddr->allocated_chunks || pcaddr->allocated_chunks > MaxChunksPreCompressedPage(chunk_size))
+	{
+		if (zero_damaged_pages || InRecovery)
+		{
+			MemSet(buffer, 0, BLCKSZ);
+			return;
+		}
+		else
+			ereport(ERROR,
+					(errcode(ERRCODE_DATA_CORRUPTED),
+					 errmsg("invalid chunks %u/%u of block %u in file \"%s\"",
+							nchunks, pcaddr->allocated_chunks, blocknum, FilePathName(v->mdfd_vfd_pca))));
+	}
+
+	for (i = 0; i < nchunks; i++)
+	{
+		if (pcaddr->chunknos[i] <= 0 || pcaddr->chunknos[i] > MAX_PAGE_COMPRESS_CHUNK_NUMBER(chunk_size))
+		{
+			if (zero_damaged_pages || InRecovery)
+			{
+				MemSet(buffer, 0, BLCKSZ);
+				return;
+			}
+			else
+				ereport(ERROR,
+						(errcode(ERRCODE_DATA_CORRUPTED),
+						 errmsg("invalid chunk number %u of block %u in file \"%s\"",
+								pcaddr->chunknos[i], blocknum, FilePathName(v->mdfd_vfd_pca))));
+		}
+	}
+
+	/* read chunk data */
+	compress_buffer = palloc(chunk_size * nchunks);
+	for (i = 0; i < nchunks; i++)
+	{
+		buffer_pos = compress_buffer + chunk_size * i;
+		seekpos = (off_t) OffsetOfPageCompressChunk(chunk_size, pcaddr->chunknos[i]);
+		range = 1;
+		while (i < nchunks - 1 && pcaddr->chunknos[i + 1] == pcaddr->chunknos[i] + 1)
+		{
+			range++;
+			i++;
+		}
+		read_amount = chunk_size * range;
+
+		TRACE_POSTGRESQL_SMGR_MD_READ_START(forknum, blocknum,
+											reln->smgr_rlocator.locator.spcNode,
+											reln->smgr_rlocator.locator.dbNode,
+											reln->smgr_rlocator.locator.relNode,
+											reln->smgr_rlocator.backend);
+
+		nbytes = FileRead(v->mdfd_vfd_pcd, buffer_pos, read_amount, seekpos, WAIT_EVENT_DATA_FILE_READ);
+
+		TRACE_POSTGRESQL_SMGR_MD_READ_DONE(forknum, blocknum,
+										   reln->smgr_rlocator.locator.spcNode,
+										   reln->smgr_rlocator.locator.dbNode,
+										   reln->smgr_rlocator.locator.relNode,
+										   reln->smgr_rlocator.backend,
+										   nbytes,
+										   read_amount);
+
+		if (nbytes != read_amount)
+		{
+			if (nbytes < 0)
+				ereport(ERROR,
+						(errcode_for_file_access(),
+						 errmsg("could not read block %u in file \"%s\": %m",
+								blocknum, FilePathName(v->mdfd_vfd_pcd))));
+
+			/*
+			 * Short read: we are at or past EOF, or we read a partial block
+			 * at EOF.  Normally this is an error; upper levels should never
+			 * try to read a nonexistent block.  However, if
+			 * zero_damaged_pages is ON or we are InRecovery, we should
+			 * instead return zeroes without complaining.  This allows, for
+			 * example, the case of trying to update a block that was later
+			 * truncated away.
+			 */
+			if (zero_damaged_pages || InRecovery)
+			{
+				pfree(compress_buffer);
+				MemSet(buffer, 0, BLCKSZ);
+				return;
+			}
+			else
+				ereport(ERROR,
+						(errcode(ERRCODE_DATA_CORRUPTED),
+						 errmsg("could not read block %u in file \"%s\": read only %d of %d bytes",
+								blocknum, FilePathName(v->mdfd_vfd_pcd),
+								nbytes, read_amount)));
+		}
+	}
+
+	/* check chunks */
+	pcchunk = (PageCompressChunk *) compress_buffer;
+	pcdata = (PageCompressData *) (pcchunk->data);
+	if (NeedPageCompressChunksToStoreData(chunk_size, SizeOfPageCompressDataHeaderData + pcdata->size) != nchunks)
+	{
+		if (zero_damaged_pages || InRecovery)
+		{
+			pfree(compress_buffer);
+			MemSet(buffer, 0, BLCKSZ);
+			return;
+		}
+		else
+			ereport(ERROR,
+					(errcode(ERRCODE_DATA_CORRUPTED),
+					 errmsg("size of compressed data %u and chunk count %d for chunk %u of block %u are inconsistent in file \"%s\"",
+							pcdata->size, nchunks, pcaddr->chunknos[0], blocknum,
+							FilePathName(v->mdfd_vfd_pcd))));
+	}
+
+	for (i = 0; i < nchunks; i++)
+	{
+		pcchunk = (PageCompressChunk *) (compress_buffer + chunk_size * i);
+		if (pcchunk->blockno != blocknum ||
+			pcchunk->chunkseq != i + 1)
+		{
+			if (zero_damaged_pages || InRecovery)
+			{
+				pfree(compress_buffer);
+				MemSet(buffer, 0, BLCKSZ);
+				return;
+			}
+			else
+				ereport(ERROR,
+						(errcode(ERRCODE_DATA_CORRUPTED),
+						 errmsg("inconsistent chunk header %u(%d) for chunk %u of block %u(%d) in file \"%s\"",
+								pcchunk->blockno, pcchunk->chunkseq,
+								pcaddr->chunknos[i], blocknum, i + 1, FilePathName(v->mdfd_vfd_pcd))));
+		}
+	}
+
+	/* build decompress buffer  */
+	if (nchunks > 1)
+	{
+		char	   *tmp_buffer = palloc(chunk_size * nchunks);
+
+		for (i = 0; i < nchunks; i++)
+		{
+			memcpy(tmp_buffer + SizeOfPageCompressChunkHeaderData + StoreCapacityPerPageCompressChunk(chunk_size) * i,
+				   compress_buffer + SizeOfPageCompressChunkHeaderData + chunk_size * i,
+				   StoreCapacityPerPageCompressChunk(chunk_size));
+		}
+		pfree(compress_buffer);
+		compress_buffer = tmp_buffer;
+		pcchunk = (PageCompressChunk *) compress_buffer;
+		pcdata = (PageCompressData *) (pcchunk->data);
+	}
+
+	/* decompress chunk data */
+	nbytes = decompress_page((char *) pcdata, buffer, PAGE_COMPRESS_ALGORITHM(reln));
+	if (nbytes != BLCKSZ)
+	{
+		if (nbytes == -2)
+			ereport(ERROR,
+					(errcode(ERRCODE_DATA_CORRUPTED),
+					 errmsg("could not recognized compression algorithm %d for file \"%s\"",
+							PAGE_COMPRESS_ALGORITHM(reln),
+							FilePathName(v->mdfd_vfd_pcd))));
+
+		/*
+		 * Short read: we are at or past EOF, or we read a partial block at
+		 * EOF.  Normally this is an error; upper levels should never try to
+		 * read a nonexistent block.  However, if zero_damaged_pages is ON or
+		 * we are InRecovery, we should instead return zeroes without
+		 * complaining.  This allows, for example, the case of trying to
+		 * update a block that was later truncated away.
+		 */
+		if (zero_damaged_pages || InRecovery)
+		{
+			pfree(compress_buffer);
+			MemSet(buffer, 0, BLCKSZ);
+			return;
+		}
+		else
+			ereport(ERROR,
+					(errcode(ERRCODE_DATA_CORRUPTED),
+					 errmsg("could not decompress block %u in file \"%s\": decompressed %d of %d bytes",
+							blocknum, FilePathName(v->mdfd_vfd_pcd),
+							nbytes, BLCKSZ)));
+	}
+
+	pfree(compress_buffer);
+}
